#ifndef UTILS_SPAWN_POINT_HPP
#define UTILS_SPAWN_POINT_HPP

#include <godot_cpp/classes/node3d.hpp>

namespace gd = godot;

namespace utils {
/*! A location in the game world that the player can spawn at.
 *
 * Registers and de-registers itself with the GameRoot3D to enable/disable this spawnpoint.
 */
class SpawnPoint3D : public gd::Node3D {
    GDCLASS(SpawnPoint3D, gd::Node3D);
    static void _bind_methods();
public:
    virtual void _enter_tree() override;
    virtual void _exit_tree() override;
};
}

#endif // !UTILS_SPAWN_POINT_HPP
